# Viam TypeScript SDK

Build and connect to robots with TypeScript

[![license](https://img.shields.io/badge/license-Apache_2.0-blue)](https://github.com/viamrobotics/viam-typescript-sdk/blob/main/LICENSE)
[![npm](https://img.shields.io/npm/v/@viamrobotics/sdk?color=33cd56&logo=npm)](https://www.npmjs.com/package/@viamrobotics/sdk)
[![documentation](https://img.shields.io/static/v1?label=docs&message=ts.viam.dev&color=lightgray)](https://ts.viam.dev)

## (In)stability Notice

> **Warning**
> This is a beta release of the Viam TypeScript SDK. Stability is not guaranteed. Breaking changes are likely to occur, and occur often.

## Usage

### Installation

```
npm install @viamrobotics/sdk
```

### Examples

[The examples directory](https://github.com/viamrobotics/viam-typescript-sdk/tree/main/examples) contains small apps that demonstrate how to use this SDK to operate a robot running Viam.

### Documentation

[https://ts.viam.dev](https://ts.viam.dev/)

## Node

To use this SDK with node, read the [documentation](https://github.com/viamrobotics/viam-typescript-sdk/blob/main/Node.md) or view the [example](https://github.com/viamrobotics/viam-typescript-sdk/tree/main/examples/node)

## React Native

To use this SDK with React Native, read the [documentation](https://github.com/viamrobotics/viam-typescript-sdk/blob/main/ReactNative.md) or view the [example](https://github.com/viamrobotics/viam-typescript-sdk/tree/main/examples/react-native/)

## Offline Mode

> [!WARNING]
> Using the typescript SDK in offline mode necessitates disabling TLS verification and so should be done with caution.

To use the browser on a local network with limited-or-no internet, follow these instructions:
```
1. start viam-server with the `-no-tls` flag
2. set the signaling server in typescript to `http://{HOST}.local:8080`
```

## License

Copyright 2022-2025 Viam Inc.

Apache 2.0 - See [LICENSE](https://github.com/viamrobotics/viam-typescript-sdk/blob/main/LICENSE) file
