import { Struct, type JsonValue } from '@bufbuild/protobuf';
import type { CallOptions } from '@connectrpc/connect';
import { JointPositions } from '../../gen/component/arm/v1/arm_pb';
import type { RobotClient } from '../../robot';
import type { Options, Pose } from '../../types';
import type { Arm } from './arm';
/**
 * A gRPC-web client for the Arm component.
 *
 * @group Clients
 */
export declare class ArmClient implements Arm {
    private client;
    readonly name: string;
    private readonly options;
    callOptions: CallOptions;
    constructor(client: RobotClient, name: string, options?: Options);
    getEndPosition(extra?: {}, callOptions?: CallOptions): Promise<import("../../gen/common/v1/common_pb").Pose>;
    getGeometries(extra?: {}, callOptions?: CallOptions): Promise<import("../../gen/common/v1/common_pb").Geometry[]>;
    moveToPosition(pose: Pose, extra?: {}, callOptions?: CallOptions): Promise<void>;
    moveToJointPositions(jointPositionsList: number[], extra?: {}, callOptions?: CallOptions): Promise<void>;
    getJointPositions(extra?: {}, callOptions?: CallOptions): Promise<JointPositions>;
    stop(extra?: {}, callOptions?: CallOptions): Promise<void>;
    isMoving(callOptions?: CallOptions): Promise<boolean>;
    doCommand(command: Struct, callOptions?: CallOptions): Promise<JsonValue>;
}
