import { Struct, type JsonValue } from '@bufbuild/protobuf';
import type { CallOptions } from '@connectrpc/connect';
import type { RobotClient } from '../../robot';
import type { Options } from '../../types';
import type { Button } from './button';
/**
 * A gRPC-web client for the Button component.
 *
 * @group Clients
 */
export declare class ButtonClient implements Button {
    private client;
    readonly name: string;
    private readonly options;
    callOptions: CallOptions;
    constructor(client: RobotClient, name: string, options?: Options);
    push(extra?: {}, callOptions?: CallOptions): Promise<void>;
    doCommand(command: Struct, callOptions?: CallOptions): Promise<JsonValue>;
}
