import { Struct, type JsonValue } from '@bufbuild/protobuf';
import type { CallOptions } from '@connectrpc/connect';
import type { RobotClient } from '../../robot';
import type { Options } from '../../types';
import { EncoderPositionType, type Encoder } from './encoder';
/**
 * A gRPC-web client for the Encoder component.
 *
 * @group Clients
 */
export declare class EncoderClient implements Encoder {
    private client;
    readonly name: string;
    private readonly options;
    callOptions: CallOptions;
    constructor(client: RobotClient, name: string, options?: Options);
    resetPosition(extra?: {}, callOptions?: CallOptions): Promise<void>;
    getProperties(extra?: {}, callOptions?: CallOptions): Promise<import("../../gen/component/encoder/v1/encoder_pb").GetPropertiesResponse>;
    getPosition(positionType?: EncoderPositionType, extra?: {}, callOptions?: CallOptions): Promise<readonly [number, import("../../gen/component/encoder/v1/encoder_pb").PositionType]>;
    doCommand(command: Struct, callOptions?: CallOptions): Promise<JsonValue>;
}
