import { Struct, type JsonValue } from '@bufbuild/protobuf';
import type { CallOptions } from '@connectrpc/connect';
import type { RobotClient } from '../../robot';
import type { Options } from '../../types';
import type { Gantry } from './gantry';
/**
 * A gRPC-web client for the Gantry component.
 *
 * @group Clients
 */
export declare class GantryClient implements Gantry {
    private client;
    readonly name: string;
    private readonly options;
    callOptions: CallOptions;
    constructor(client: RobotClient, name: string, options?: Options);
    getGeometries(extra?: {}, callOptions?: CallOptions): Promise<import("../../gen/common/v1/common_pb").Geometry[]>;
    getPosition(extra?: {}, callOptions?: CallOptions): Promise<number[]>;
    moveToPosition(positionsMm: number[], speedsMmPerSec: number[], extra?: {}, callOptions?: CallOptions): Promise<void>;
    home(extra?: {}, callOptions?: CallOptions): Promise<boolean>;
    getLengths(extra?: {}, callOptions?: CallOptions): Promise<number[]>;
    stop(extra?: {}, callOptions?: CallOptions): Promise<void>;
    isMoving(callOptions?: CallOptions): Promise<boolean>;
    doCommand(command: Struct, callOptions?: CallOptions): Promise<JsonValue>;
}
