import { type JsonValue, Struct } from '@bufbuild/protobuf';
import type { CallOptions } from '@connectrpc/connect';
import type { RobotClient } from '../../robot';
import type { Options } from '../../types';
import type { Generic } from './generic';
/**
 * A gRPC-web client for the Generic component.
 *
 * @group Clients
 */
export declare class GenericClient implements Generic {
    private client;
    readonly name: string;
    private readonly options;
    callOptions: CallOptions;
    constructor(client: RobotClient, name: string, options?: Options);
    getGeometries(extra?: {}, callOptions?: CallOptions): Promise<import("../../gen/common/v1/common_pb").Geometry[]>;
    doCommand(command: Struct, callOptions?: CallOptions): Promise<JsonValue>;
}
