import type { RobotClient } from '../../robot';
import type { Options } from '../../types';
import { Struct, type JsonValue } from '@bufbuild/protobuf';
import type { CallOptions } from '@connectrpc/connect';
import type { InputController, InputControllerEvent } from './input-controller';
/**
 * A gRPC-web client for the Input Controller component.
 *
 * @group Clients
 */
export declare class InputControllerClient implements InputController {
    private client;
    readonly name: string;
    private readonly options;
    callOptions: CallOptions;
    constructor(client: RobotClient, name: string, options?: Options);
    getEvents(extra?: {}, callOptions?: CallOptions): Promise<import("../../gen/component/inputcontroller/v1/input_controller_pb").Event[]>;
    triggerEvent(event: InputControllerEvent, extra?: {}, callOptions?: CallOptions): Promise<void>;
    doCommand(command: Struct, callOptions?: CallOptions): Promise<JsonValue>;
}
