import type { RobotClient } from '../../robot';
import type { Options } from '../../types';
import { Struct, type JsonValue } from '@bufbuild/protobuf';
import type { CallOptions } from '@connectrpc/connect';
import type { Sensor } from './sensor';
/**
 * A gRPC-web client for the Sensor component.
 *
 * @group Clients
 */
export declare class SensorClient implements Sensor {
    private client;
    readonly name: string;
    private readonly options;
    callOptions: CallOptions;
    constructor(client: RobotClient, name: string, options?: Options);
    getReadings(extra?: {}, callOptions?: CallOptions): Promise<Record<string, JsonValue>>;
    doCommand(command: Struct, callOptions?: CallOptions): Promise<JsonValue>;
}
