import { Struct, type JsonValue } from '@bufbuild/protobuf';
import type { CallOptions } from '@connectrpc/connect';
import type { RobotClient } from '../../robot';
import type { Options } from '../../types';
import type { Servo } from './servo';
/**
 * A gRPC-web client for the Servo component.
 *
 * @group Clients
 */
export declare class ServoClient implements Servo {
    private client;
    readonly name: string;
    private readonly options;
    callOptions: CallOptions;
    constructor(client: RobotClient, name: string, options?: Options);
    move(angleDeg: number, extra?: {}, callOptions?: CallOptions): Promise<void>;
    getPosition(extra?: {}, callOptions?: CallOptions): Promise<number>;
    stop(extra?: {}, callOptions?: CallOptions): Promise<void>;
    isMoving(callOptions?: CallOptions): Promise<boolean>;
    doCommand(command: Struct, callOptions?: CallOptions): Promise<JsonValue>;
}
