import { Struct, type JsonValue } from '@bufbuild/protobuf';
import type { CallOptions } from '@connectrpc/connect';
import type { RobotClient } from '../../robot';
import type { Options } from '../../types';
import type { Switch } from './switch';
/**
 * A gRPC-web client for the Switch component.
 *
 * @group Clients
 */
export declare class SwitchClient implements Switch {
    private client;
    readonly name: string;
    private readonly options;
    callOptions: CallOptions;
    constructor(client: RobotClient, name: string, options?: Options);
    setPosition(position: number, extra?: {}, callOptions?: CallOptions): Promise<void>;
    getPosition(extra?: {}, callOptions?: CallOptions): Promise<number>;
    getNumberOfPositions(extra?: {}, callOptions?: CallOptions): Promise<number>;
    doCommand(command: Struct, callOptions?: CallOptions): Promise<JsonValue>;
}
