// @generated by protoc-gen-connect-es v1.5.0
// @generated from file component/camera/v1/camera.proto (package viam.component.camera.v1, syntax proto3)
/* eslint-disable */
// @ts-nocheck

import { GetImageRequest, GetImageResponse, GetImagesRequest, GetImagesResponse, GetPointCloudRequest, GetPointCloudResponse, GetPropertiesRequest, GetPropertiesResponse, RenderFrameRequest } from "./camera_pb.js";
import { MethodKind } from "@bufbuild/protobuf";
import { HttpBody } from "../../../google/api/httpbody_pb.js";
import { DoCommandRequest, DoCommandResponse, GetGeometriesRequest, GetGeometriesResponse } from "../../../common/v1/common_pb.js";

/**
 * A CameraService services all cameras associated with a robot
 *
 * @generated from service viam.component.camera.v1.CameraService
 */
export declare const CameraService: {
  readonly typeName: "viam.component.camera.v1.CameraService",
  readonly methods: {
    /**
     * GetImage returns a frame from a camera of the underlying robot. A specific MIME type
     * can be requested but may not necessarily be the same one returned.
     *
     * @generated from rpc viam.component.camera.v1.CameraService.GetImage
     */
    readonly getImage: {
      readonly name: "GetImage",
      readonly I: typeof GetImageRequest,
      readonly O: typeof GetImageResponse,
      readonly kind: MethodKind.Unary,
    },
    /**
     * @generated from rpc viam.component.camera.v1.CameraService.GetImages
     */
    readonly getImages: {
      readonly name: "GetImages",
      readonly I: typeof GetImagesRequest,
      readonly O: typeof GetImagesResponse,
      readonly kind: MethodKind.Unary,
    },
    /**
     * RenderFrame renders a frame from a camera of the underlying robot to an HTTP response. A specific MIME type
     * can be requested but may not necessarily be the same one returned.
     *
     * @generated from rpc viam.component.camera.v1.CameraService.RenderFrame
     */
    readonly renderFrame: {
      readonly name: "RenderFrame",
      readonly I: typeof RenderFrameRequest,
      readonly O: typeof HttpBody,
      readonly kind: MethodKind.Unary,
    },
    /**
     * GetPointCloud returns a point cloud from a camera of the underlying robot. A specific MIME type
     * can be requested but may not necessarily be the same one returned.
     *
     * @generated from rpc viam.component.camera.v1.CameraService.GetPointCloud
     */
    readonly getPointCloud: {
      readonly name: "GetPointCloud",
      readonly I: typeof GetPointCloudRequest,
      readonly O: typeof GetPointCloudResponse,
      readonly kind: MethodKind.Unary,
    },
    /**
     * GetProperties returns the camera intrinsic parameters and camera distortion parameters from a camera of the underlying robot, if available.
     *
     * @generated from rpc viam.component.camera.v1.CameraService.GetProperties
     */
    readonly getProperties: {
      readonly name: "GetProperties",
      readonly I: typeof GetPropertiesRequest,
      readonly O: typeof GetPropertiesResponse,
      readonly kind: MethodKind.Unary,
    },
    /**
     * DoCommand sends/receives arbitrary commands
     *
     * @generated from rpc viam.component.camera.v1.CameraService.DoCommand
     */
    readonly doCommand: {
      readonly name: "DoCommand",
      readonly I: typeof DoCommandRequest,
      readonly O: typeof DoCommandResponse,
      readonly kind: MethodKind.Unary,
    },
    /**
     * GetGeometries returns the geometries of the component in their current configuration
     *
     * @generated from rpc viam.component.camera.v1.CameraService.GetGeometries
     */
    readonly getGeometries: {
      readonly name: "GetGeometries",
      readonly I: typeof GetGeometriesRequest,
      readonly O: typeof GetGeometriesResponse,
      readonly kind: MethodKind.Unary,
    },
  }
};

