// Copyright 2025 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// @generated by protoc-gen-es v1.10.0
// @generated from file google/api/field_info.proto (package google.api, syntax proto3)
/* eslint-disable */
// @ts-nocheck

import type { BinaryReadOptions, Extension, FieldList, FieldOptions, JsonReadOptions, JsonValue, PartialMessage, PlainMessage } from "@bufbuild/protobuf";
import { Message, proto3 } from "@bufbuild/protobuf";

/**
 * Rich semantic information of an API field beyond basic typing.
 *
 * @generated from message google.api.FieldInfo
 */
export declare class FieldInfo extends Message<FieldInfo> {
  /**
   * The standard format of a field value. This does not explicitly configure
   * any API consumer, just documents the API's format for the field it is
   * applied to.
   *
   * @generated from field: google.api.FieldInfo.Format format = 1;
   */
  format: FieldInfo_Format;

  /**
   * The type(s) that the annotated, generic field may represent.
   *
   * Currently, this must only be used on fields of type `google.protobuf.Any`.
   * Supporting other generic types may be considered in the future.
   *
   * @generated from field: repeated google.api.TypeReference referenced_types = 2;
   */
  referencedTypes: TypeReference[];

  constructor(data?: PartialMessage<FieldInfo>);

  static readonly runtime: typeof proto3;
  static readonly typeName = "google.api.FieldInfo";
  static readonly fields: FieldList;

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): FieldInfo;

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): FieldInfo;

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): FieldInfo;

  static equals(a: FieldInfo | PlainMessage<FieldInfo> | undefined, b: FieldInfo | PlainMessage<FieldInfo> | undefined): boolean;
}

/**
 * The standard format of a field value. The supported formats are all backed
 * by either an RFC defined by the IETF or a Google-defined AIP.
 *
 * @generated from enum google.api.FieldInfo.Format
 */
export declare enum FieldInfo_Format {
  /**
   * Default, unspecified value.
   *
   * @generated from enum value: FORMAT_UNSPECIFIED = 0;
   */
  FORMAT_UNSPECIFIED = 0,

  /**
   * Universally Unique Identifier, version 4, value as defined by
   * https://datatracker.ietf.org/doc/html/rfc4122. The value may be
   * normalized to entirely lowercase letters. For example, the value
   * `F47AC10B-58CC-0372-8567-0E02B2C3D479` would be normalized to
   * `f47ac10b-58cc-0372-8567-0e02b2c3d479`.
   *
   * @generated from enum value: UUID4 = 1;
   */
  UUID4 = 1,

  /**
   * Internet Protocol v4 value as defined by [RFC
   * 791](https://datatracker.ietf.org/doc/html/rfc791). The value may be
   * condensed, with leading zeros in each octet stripped. For example,
   * `001.022.233.040` would be condensed to `1.22.233.40`.
   *
   * @generated from enum value: IPV4 = 2;
   */
  IPV4 = 2,

  /**
   * Internet Protocol v6 value as defined by [RFC
   * 2460](https://datatracker.ietf.org/doc/html/rfc2460). The value may be
   * normalized to entirely lowercase letters with zeros compressed, following
   * [RFC 5952](https://datatracker.ietf.org/doc/html/rfc5952). For example,
   * the value `2001:0DB8:0::0` would be normalized to `2001:db8::`.
   *
   * @generated from enum value: IPV6 = 3;
   */
  IPV6 = 3,

  /**
   * An IP address in either v4 or v6 format as described by the individual
   * values defined herein. See the comments on the IPV4 and IPV6 types for
   * allowed normalizations of each.
   *
   * @generated from enum value: IPV4_OR_IPV6 = 4;
   */
  IPV4_OR_IPV6 = 4,
}

/**
 * A reference to a message type, for use in [FieldInfo][google.api.FieldInfo].
 *
 * @generated from message google.api.TypeReference
 */
export declare class TypeReference extends Message<TypeReference> {
  /**
   * The name of the type that the annotated, generic field may represent.
   * If the type is in the same protobuf package, the value can be the simple
   * message name e.g., `"MyMessage"`. Otherwise, the value must be the
   * fully-qualified message name e.g., `"google.library.v1.Book"`.
   *
   * If the type(s) are unknown to the service (e.g. the field accepts generic
   * user input), use the wildcard `"*"` to denote this behavior.
   *
   * See [AIP-202](https://google.aip.dev/202#type-references) for more details.
   *
   * @generated from field: string type_name = 1;
   */
  typeName: string;

  constructor(data?: PartialMessage<TypeReference>);

  static readonly runtime: typeof proto3;
  static readonly typeName = "google.api.TypeReference";
  static readonly fields: FieldList;

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): TypeReference;

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): TypeReference;

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): TypeReference;

  static equals(a: TypeReference | PlainMessage<TypeReference> | undefined, b: TypeReference | PlainMessage<TypeReference> | undefined): boolean;
}

/**
 * Rich semantic descriptor of an API field beyond the basic typing.
 *
 * Examples:
 *
 *     string request_id = 1 [(google.api.field_info).format = UUID4];
 *     string old_ip_address = 2 [(google.api.field_info).format = IPV4];
 *     string new_ip_address = 3 [(google.api.field_info).format = IPV6];
 *     string actual_ip_address = 4 [
 *       (google.api.field_info).format = IPV4_OR_IPV6
 *     ];
 *     google.protobuf.Any generic_field = 5 [
 *       (google.api.field_info).referenced_types = {type_name: "ActualType"},
 *       (google.api.field_info).referenced_types = {type_name: "OtherType"},
 *     ];
 *     google.protobuf.Any generic_user_input = 5 [
 *       (google.api.field_info).referenced_types = {type_name: "*"},
 *     ];
 *
 * @generated from extension: google.api.FieldInfo field_info = 291403980;
 */
export declare const field_info: Extension<FieldOptions, FieldInfo>;

