import type { Message, PartialMessage } from '@bufbuild/protobuf';
import type { ContextValues, UnaryResponse } from '@connectrpc/connect';
import { ResponseHeaders, ResponseTrailers } from '../gen/proto/rpc/webrtc/v1/grpc_pb';
import { ClientStream } from './client-stream';
export declare class UnaryClientStream<I extends Message<I>, O extends Message<O>> extends ClientStream<I, O> {
    private result?;
    private headers?;
    private message?;
    run(signal: AbortSignal | undefined, timeoutMs: number | undefined, message: PartialMessage<I>, contextValues?: ContextValues): Promise<UnaryResponse<I, O>>;
    protected onHeaders(headers: ResponseHeaders): void;
    protected onTrailers(respTrailers: ResponseTrailers): void;
    protected onMessage(msgBytes: Uint8Array): void;
}
