import { Struct, type JsonValue } from '@bufbuild/protobuf';
import type { CallOptions } from '@connectrpc/connect';
import type { RobotClient } from '../../robot';
import type { Options } from '../../types';
import type { Discovery } from './discovery';
/**
 * A gRPC-web client for a Vision service.
 *
 * @group Clients
 */
export declare class DiscoveryClient implements Discovery {
    private client;
    readonly name: string;
    private readonly options;
    callOptions: CallOptions;
    constructor(client: RobotClient, name: string, options?: Options);
    discoverResources(extra?: {}, callOptions?: CallOptions): Promise<import("../../gen/app/v1/robot_pb").ComponentConfig[]>;
    doCommand(command: Struct, callOptions?: CallOptions): Promise<JsonValue>;
}
